
;.include "packetDefines.inc"		;definition of parameters for UDP packet transmition
					;edit this file for your required values(MAC, IP, port)

;.include "compute_crc.inc"

.def	RegForEth0              =R0             ;register containing log.0 value for transmitting
.def	RegForEth1              =R1		;register containing log.1 value for transmitting

.def	RegForEth0bit0		=R2		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit0		=R3		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth0bit1		=R4		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit1		=R5		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth0bit2		=R6		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit2		=R7		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth0bit3		=R8		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit3		=R9		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth0bit4		=R10		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit4		=R11		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth0bit5		=R12		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit5		=R13		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth0bit6		=R14		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit6		=R15		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth0bit7		=R22		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)
.def	RegForEth1bit7		=R23		;register containing log.1 or log.0 value for transmitting (in data part of UDPpacket)

.def	temp0                   =R16		;temporary register
.def	temp1			=R17		;temporary register
.def	temp2			=R18		;temporary register
.def	temp3			=R19		;temporary register
.def	temp4			=R20		;temporary register
.def	temp5			=R21		;temporary register

;------------------------------------------------------------------------------------------
;********************************************************************
;* Macros for fast transmitting definition
;********************************************************************
;------------------------------------------------------------------------------------------
.MACRO EthSend0                                 ;send to Ethport logical 0
        out     EthPort,RegForEth0
        out     EthPort,RegForEth1

.ENDMACRO                       ;
;------------------------------------------------------------------------------------------
.MACRO EthSend1                                 ;send to Ethport logical 1
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0
.ENDMACRO
;------------------------------------------------------------------------------------------
.MACRO EthSendByte				;send to Ethport byte (given as parameter1)
	CRCbyte @0
	.if ((@0 >> 0)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
	.if ((@0 >> 1)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
	.if ((@0 >> 2)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
	.if ((@0 >> 3)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
	.if ((@0 >> 4)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
	.if ((@0 >> 5)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
	.if ((@0 >> 6)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
	.if ((@0 >> 7)&1)
          out     EthPort,RegForEth1
          out     EthPort,RegForEth0
	.else
          out     EthPort,RegForEth0
          out     EthPort,RegForEth1
	.endif
.ENDMACRO

;------------------------------------------------------------------------------------------
;********************************************************************
;* Macros for preparing, starting and ending transmission
;********************************************************************
;------------------------------------------------------------------------------------------

.MACRO prepare_ethsend
; prepare registers as needed for ethernet transmission
	push	temp0
	push	temp1
	push	RegForEth0
	push	RegForEth1

        in      temp0, EthPort                  ;load port state
        cbr     temp0, (1<<TxPlusPin)|(1<<TxMinusPin)          ;clear TX+ and TX-
	mov	temp1,temp0			;store the default state for recovering

	sbr     temp0, (1<<TxMinusPin)          ;set TX- (TX+ was cleared)
        mov     RegForEth0, temp0               ;and store as log0 state

        sbr     temp0, (1<<TxPlusPin)           ;set TX+
        cbr     temp0, (1<<TxMinusPin)          ;clear TX-
        mov     RegForEth1, temp0               ;and store as log1 state
.ENDMACRO

.MACRO ethsend_TP_IDL
; nicely finish the packet by sending the TP_IDL sequence
	out     EthPort,RegForEth0
	nop
	nop
	nop
	nop
	nop
.ENDMACRO

.MACRO start_ethsend
; actually enable the transmission
        cli					; now disable interrupts: don't want to be disturbed while sending bits
	out     EthPort,RegForEth0		;initalise pins such that as soon as we enable them, there's a differential voltage over the cable; otherwise, the common mode voltage will bounce
        in      temp0, EthPortDirection         ;load Ethport direction
        sbr     temp0, (1<<TxMinusPin)|(1<<TxPlusPin) ;enable transmitter pins
        out     EthPortDirection, temp0         ;and write back to direction reg - start transmitting
.ENDMACRO

.MACRO stop_ethsend
; disable the transmission
        cbr     temp0, (1<<TxMinusPin)|(1<<TxPlusPin) ;disable transmiter pins
        out     EthPortDirection, temp0         ;and write back to direction reg - stop transmitting
	out     EthPort,temp1			;recover default state
	sei					; can safely re-enable interrupts now
.ENDMACRO

.MACRO finalize_ethsend
; restore registers, converse of prepare_ethsend
	pop	RegForEth1
	pop	RegForEth0
	pop	temp1
	pop	temp0
.ENDMACRO


.MACRO InitEthSend                              ;initialize Eth sending
	prepare_ethsend
	start_ethsend
.ENDMACRO


.MACRO CloseEthSend                             ;closes Eth sending
	ethsend_TP_IDL
	stop_ethsend
	finalize_ethsend
.ENDMACRO



;------------------------------------------------------------------------------------------

.MACRO InitEthSendUDP                              ;initialize Eth sending for UDP; this is more work, because we need to prepare lots of registers for sending the databits
	prepare_ethsend

	push	temp2
	push	RegForEth0bit0
	push	RegForEth1bit0
	push	RegForEth0bit1
	push	RegForEth1bit1
	push	RegForEth0bit2
	push	RegForEth1bit2
	push	RegForEth0bit3
	push	RegForEth1bit3
	push	RegForEth0bit4
	push	RegForEth1bit4
	push	RegForEth0bit5
	push	RegForEth1bit5
	push	RegForEth0bit6
	push	RegForEth1bit6
	push	RegForEth0bit7
	push	RegForEth1bit7
	
	mov	RegForEth0bit0,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit0,RegForEth1

	mov	RegForEth0bit1,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit1,RegForEth1

	mov	RegForEth0bit2,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit2,RegForEth1

	mov	RegForEth0bit3,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit3,RegForEth1

	mov	RegForEth0bit4,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit4,RegForEth1

	mov	RegForEth0bit5,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit5,RegForEth1

	mov	RegForEth0bit6,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit6,RegForEth1

	mov	RegForEth0bit7,RegForEth0		;assign to UDPBit value
	mov	RegForEth1bit7,RegForEth1


	bst	temp2,0					;store bit to T
	bld	RegForEth0bit0,TxMinusPin		;and store it to given register
	bld	RegForEth1bit0,TxPlusPin

	bst	temp2,1					;store bit to T
	bld	RegForEth0bit1,TxMinusPin		;and store it to given register
	bld	RegForEth1bit1,TxPlusPin

	bst	temp2,2					;store bit to T
	bld	RegForEth0bit2,TxMinusPin		;and store it to given register
	bld	RegForEth1bit2,TxPlusPin

	bst	temp2,3					;store bit to T
	bld	RegForEth0bit3,TxMinusPin		;and store it to given register
	bld	RegForEth1bit3,TxPlusPin

	bst	temp2,4					;store bit to T
	bld	RegForEth0bit4,TxMinusPin		;and store it to given register
	bld	RegForEth1bit4,TxPlusPin

	bst	temp2,5					;store bit to T
	bld	RegForEth0bit5,TxMinusPin		;and store it to given register
	bld	RegForEth1bit5,TxPlusPin

	bst	temp2,6					;store bit to T
	bld	RegForEth0bit6,TxMinusPin		;and store it to given register
	bld	RegForEth1bit6,TxPlusPin

	bst	temp2,7					;store bit to T
	bld	RegForEth0bit7,TxMinusPin		;and store it to given register
	bld	RegForEth1bit7,TxPlusPin


	;--------------------------------------------------------------
	com	temp2					;invert bits

	bst	temp2,0					;store bit to T
	bld	RegForEth1bit0,TxMinusPin		;and store it to given register
	bld	RegForEth0bit0,TxPlusPin

	bst	temp2,1					;store bit to T
	bld	RegForEth1bit1,TxMinusPin		;and store it to given register
	bld	RegForEth0bit1,TxPlusPin

	bst	temp2,2					;store bit to T
	bld	RegForEth1bit2,TxMinusPin		;and store it to given register
	bld	RegForEth0bit2,TxPlusPin

	bst	temp2,3					;store bit to T
	bld	RegForEth1bit3,TxMinusPin		;and store it to given register
	bld	RegForEth0bit3,TxPlusPin

	bst	temp2,4					;store bit to T
	bld	RegForEth1bit4,TxMinusPin		;and store it to given register
	bld	RegForEth0bit4,TxPlusPin

	bst	temp2,5					;store bit to T
	bld	RegForEth1bit5,TxMinusPin		;and store it to given register
	bld	RegForEth0bit5,TxPlusPin

	bst	temp2,6					;store bit to T
	bld	RegForEth1bit6,TxMinusPin		;and store it to given register
	bld	RegForEth0bit6,TxPlusPin

	bst	temp2,7					;store bit to T
	bld	RegForEth1bit7,TxMinusPin		;and store it to given register
	bld	RegForEth0bit7,TxPlusPin

	start_ethsend

.ENDMACRO

;------------------------------------------------------------------------------------------
.MACRO CloseEthSendUDP                             ;closes Eth sending for UDP
	ethsend_TP_IDL
	stop_ethsend

	pop	RegForEth1bit7		;restore all used registers (can be used in main program)
	pop	RegForEth0bit7
	pop	RegForEth1bit6
	pop	RegForEth0bit6
	pop	RegForEth1bit5
	pop	RegForEth0bit5
	pop	RegForEth1bit4
	pop	RegForEth0bit4
	pop	RegForEth1bit3
	pop	RegForEth0bit3
	pop	RegForEth1bit2
	pop	RegForEth0bit2
	pop	RegForEth1bit1
	pop	RegForEth0bit1
	pop	RegForEth1bit0
	pop	RegForEth0bit0
	pop	temp2

	finalize_ethsend
.ENDMACRO

;********************************************************************
;* End of Macros definition
;********************************************************************
;------------------------------------------------------------------------------------------


;********************************************************************
;* Subroutines
;********************************************************************

;------------------------------------------------------------------------------------------
Delay10us:	;used for interframe delay required by ethernet specification between packets
		push	temp4
		ldi	temp4,62
  Delay10usLoop:
		dec	temp4
		brne	Delay10usLoop
		pop	temp4
		ret


Delay1ms:	
		push	temp4
		ldi	temp4,100
  Delay1msLoop:
  		call Delay10us
		dec	temp4
		brne	Delay1msLoop
		pop	temp4
		ret

;------------------------------------------------------------------------------------------

SendNLP:	;Normal Link Pulse sending (to be sent every ca. 13ms : specification requires between 8ms and 24ms)
                InitEthSend			;start sending
        					;send signal for 100 ns (2 clock ticks) as "Normal Link Pulse"
        					;we don't need to do anything here, since the instructions in those macros already take 2 clock ticks
		stop_ethsend
		finalize_ethsend
                ret

