

;---------------------------------------------------------------------------------
; this file contains all the bit and byte level details of packet sending
;---------------------------------------------------------------------------------



;length ofdata in UDP packet
.equ	UDPDatalength=	44

;length type0x0800 = IP packet inside
.equ EthPacketType=	0x0800

;IP version=4 IP header length=5
.equ IPVersionLength=	0x45

;type of service
.equ IPTypeOfService=	0x00

;total IP length header+data=20+8+UDPDatalength
.equ IPLength=		20+8+UDPDataLength

;identification of datagram (packet counter)
.equ IPDatagramID=	0x0001

;flags and fragment offset
.equ IPFlags=		0x00
.equ IPOffset=		0x00

;time to live
.equ IPTimeToLive=	0x40

;protocol used (UDP=0x11)
.equ IPUsedProtocol=	0x11

;UDP message length (8 bytes UDP header + data)
.equ UDPMessageLength=	8+UDPDatalength

;UDP checksum - optional (not used = 0)
.equ UDPChecksum=	0x0000


;---------------------------------------------------------------------------------

.macro CRCstart
.set	CRC32init=	0xFFFFFFFF	;
.set	CRC32polyInv=	0xEDB88320	;CRC32 polynom (0x04C11DB7) in inverted bits order
.set	CRC32	=	CRC32init	;initialisation of CRC32
.endmacro

.macro CRCsend
.set    ComputedCRC32=CRC32     ; make copy of computed CRC, since the EthSendByte macro will change the CRC32 variable
EthSendByte     ((~ComputedCRC32)>> 0)  ;
EthSendByte     ((~ComputedCRC32)>> 8)  ;
EthSendByte     ((~ComputedCRC32)>>16)  ;
EthSendByte     ((~ComputedCRC32)>>24)  ;
.endmacro

.macro CRCbyte
.set	Message=	@0	;load message byte

	;bit0 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv);shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message

	;bit1 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv)	;shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message

	;bit2 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv)	;shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message

	;bit3 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv)	;shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message

	;bit4 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv)	;shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message

	;bit5 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv)	;shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message

	;bit6 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv)	;shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message

	;bit7 of message calculation
	.if ((CRC32^(Message))&1)			;if xor of CRC32[MSB] and Message[LSB] is one (note: CRC32 has now inverted bit order)
	  .set	CRC32=((CRC32>>1)^CRC32polyInv)	;shift the CRC and make xor with polynom
	.else					;if not
	  .set	CRC32=	(CRC32>>1)		;only shift the CRC
	.endif
	.set	Message=(Message>>1)		;go to next bit in Message
;end of one byte CRC processing

.endmacro

;---------------------------------------------------------------------------------

.MACRO send_packet_arp

call	Delay10us		;interframe delay (required between ethernet packets)
InitEthSend			;start sending

;  ethernet sync bits
; ethernet sync
CRCstart
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0xD5

;  actual start of packet
CRCstart  ; need to restart CRC calculation here, since sync bits shouldn't be included

;  ethernet header
;MAC dest
EthSendByte MACDestAddr5
EthSendByte MACDestAddr4
EthSendByte MACDestAddr3
EthSendByte MACDestAddr2
EthSendByte MACDestAddr1
EthSendByte MACDestAddr0

;MAC source
EthSendByte MACSourceAddr5
EthSendByte MACSourceAddr4
EthSendByte MACSourceAddr3
EthSendByte MACSourceAddr2
EthSendByte MACSourceAddr1
EthSendByte MACSourceAddr0

.equ EthPacketTypeARP=     0x0806
;length/type of packet inside
EthSendByte (EthPacketTypeARP >> 8)
EthSendByte (EthPacketTypeARP >> 0)

;  ARP header
; hardware type =1  (ethernet)
EthSendByte 0
EthSendByte 1
; protocol type =0x0800 (IPv4)
EthSendByte (0x0800 >> 8)
EthSendByte (0x0800 >> 0)
; hlen, plen
EthSendByte 6
EthSendByte 4
; operation 2 (reply)
EthSendByte (2 >> 8)
EthSendByte (2 >> 0)
; sender hw addr
EthSendByte MACSourceAddr5
EthSendByte MACSourceAddr4
EthSendByte MACSourceAddr3
EthSendByte MACSourceAddr2
EthSendByte MACSourceAddr1
EthSendByte MACSourceAddr0
; sender prot addr
EthSendByte IPSourceAddr3
EthSendByte IPSourceAddr2
EthSendByte IPSourceAddr1
EthSendByte IPSourceAddr0
; target hw addr
EthSendByte MACSourceAddr5
EthSendByte MACSourceAddr4
EthSendByte MACSourceAddr3
EthSendByte MACSourceAddr2
EthSendByte MACSourceAddr1
EthSendByte MACSourceAddr0
; target prot addr
EthSendByte IPSourceAddr3
EthSendByte IPSourceAddr2
EthSendByte IPSourceAddr1
EthSendByte IPSourceAddr0


; padding
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0
EthSendByte 0

; send CRC
CRCsend

CloseEthSend			;finish sending	
call	Delay10us		;interframe delay (required between ethernet packets)

.ENDMACRO

;---------------------------------------------------------------------------------


.MACRO EthSendByteUDPBit			;send to Ethport byte which MSB is UDPBit
	out     EthPort,RegForEth0 		;LSB
        out     EthPort,RegForEth1

	out     EthPort,RegForEth0 		;
        out     EthPort,RegForEth1

	out     EthPort,RegForEth0 		;
        out     EthPort,RegForEth1

	out     EthPort,RegForEth0 		;
        out     EthPort,RegForEth1

	out     EthPort,RegForEth0 		;
        out     EthPort,RegForEth1

	out     EthPort,RegForEth0 		;
        out     EthPort,RegForEth1

	out     EthPort,RegForEth0 		;
        out     EthPort,RegForEth1

	out     EthPort,@1			;MSB = UDP bit
	out     EthPort,@0
.ENDMACRO

;------------------------------------------------------------------------------------------
.MACRO SendCRCForZero				;set current CRC32 value of previous message
						;to zero after sending bit in register as parameter
;send CRC32 polynom = 0x04C11DB7 from MSB to LSB
	;0
        out     EthPort,RegForEth0 	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0 	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
	;4
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
	;C
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
	;1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
	;1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
	;D
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
	;B
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
	;7
        out     EthPort,RegForEth0  	;0
        out     EthPort,RegForEth1
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0
        out     EthPort,@1		;given bit (1 or 0)
        out     EthPort,@0

.ENDMACRO
;------------------------------------------------------------------------------------------


.MACRO send_packet_udp

call	Delay10us		;interframe delay (required between ethernet packets)
InitEthSendUDP			;start sending

; ethernet sync
CRCstart
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0x55
EthSendByte 0xD5

CRCstart
;MAC dest
EthSendByte MACDestAddr5
EthSendByte MACDestAddr4
EthSendByte MACDestAddr3
EthSendByte MACDestAddr2
EthSendByte MACDestAddr1
EthSendByte MACDestAddr0

;MAC source
EthSendByte MACSourceAddr5
EthSendByte MACSourceAddr4
EthSendByte MACSourceAddr3
EthSendByte MACSourceAddr2
EthSendByte MACSourceAddr1
EthSendByte MACSourceAddr0

;length/type of packet inside
EthSendByte (EthPacketType >> 8)
EthSendByte (EthPacketType >> 0)


EthSendByte IPVersionLength

EthSendByte IPTypeOfService

EthSendByte (IPLength >> 8)
EthSendByte (IPLength >> 0)

EthSendByte (IPDatagramID >> 8)
EthSendByte (IPDatagramID >> 0)

EthSendByte IPFlags
EthSendByte IPOffset

EthSendByte IPTimeToLive

EthSendByte IPUsedProtocol

.set IPchecksum=	0
.set IPchecksum=	IPchecksum + (IPVersionLength<<8) + IPTypeOfService
.set IPchecksum=	IPchecksum + (IPTypeOfService<<8) + IPLength
.set IPchecksum=	IPchecksum + IPDatagramID
.set IPchecksum=	IPchecksum + (IPFlags        <<8) + IPOffset
.set IPchecksum=	IPchecksum + (IPTimeToLive   <<8) + IPUsedProtocol
.set IPchecksum=	IPchecksum + (IPSourceAddr3  <<8) + IPSourceAddr2
.set IPchecksum=	IPchecksum + (IPSourceAddr1  <<8) + IPSourceAddr0
.set IPchecksum=	IPchecksum + (IPDestAddr3    <<8) + IPDestAddr2
.set IPchecksum=	IPchecksum + (IPDestAddr1    <<8) + IPDestAddr0
.set IPchecksum=	(~(IPchecksum + (IPchecksum>>16)))

EthSendByte (IPchecksum >> 8)
EthSendByte (IPchecksum >> 0)

EthSendByte IPSourceAddr3
EthSendByte IPSourceAddr2
EthSendByte IPSourceAddr1
EthSendByte IPSourceAddr0

EthSendByte IPDestAddr3
EthSendByte IPDestAddr2
EthSendByte IPDestAddr1
EthSendByte IPDestAddr0


;source UDP port
EthSendByte	(UDPSourcePort >> 8)
EthSendByte	(UDPSourcePort >> 0)

;destination UDP port
EthSendByte	(UDPDestPort >> 8)
EthSendByte	(UDPDestPort >> 0)

;UDP message length
EthSendByte	(UDPMessageLength >> 8)
EthSendByte	(UDPMessageLength >> 0)

;UDP checksum - optional (not used = 0)
EthSendByte	(UDPChecksum >> 8)
EthSendByte	(UDPChecksum >> 0)

.set    ComputedCRC32=~CRC32                            ;invert the result
EthSendByte	((~ComputedCRC32)>> 0)	;
EthSendByte	((~ComputedCRC32)>> 8)	;
EthSendByte	((~ComputedCRC32)>>16)	;
EthSendByte	((~ComputedCRC32)>>24)	;

EthSendByteUDPBit	RegForEth0bit0, RegForEth1bit0	;this sends the bit0 value
SendCRCForZero	 	RegForEth0bit0, RegForEth1bit0	;zero current CRC

EthSendByteUDPBit	RegForEth0bit1, RegForEth1bit1	;this sends the bit1 value
SendCRCForZero	 	RegForEth0bit1, RegForEth1bit1	;zero current CRC

EthSendByteUDPBit	RegForEth0bit2, RegForEth1bit2	;this sends the bit2 value
SendCRCForZero	 	RegForEth0bit2, RegForEth1bit2	;zero current CRC

EthSendByteUDPBit	RegForEth0bit3, RegForEth1bit3	;this sends the bit3 value
SendCRCForZero	 	RegForEth0bit3, RegForEth1bit3	;zero current CRC

EthSendByteUDPBit	RegForEth0bit4, RegForEth1bit4	;this sends the bit4 value
SendCRCForZero	 	RegForEth0bit4, RegForEth1bit4	;zero current CRC

EthSendByteUDPBit	RegForEth0bit5, RegForEth1bit5	;this sends the bit5 value
SendCRCForZero	 	RegForEth0bit5, RegForEth1bit5	;zero current CRC

EthSendByteUDPBit	RegForEth0bit6, RegForEth1bit6	;this sends the bit6 value
SendCRCForZero	 	RegForEth0bit6, RegForEth1bit6	;zero current CRC

EthSendByteUDPBit	RegForEth0bit7, RegForEth1bit7	;this sends the bit7 value
SendCRCForZero	 	RegForEth0bit7, RegForEth1bit7	;zero current CRC

;Ethernet CRC for packet
;send CRC32 polynom - because CRC was cleared - send all ones
EthSendByte	0xFF
EthSendByte	0xFF
EthSendByte	0xFF
EthSendByte	0xFF

CloseEthSendUDP			;finish sending	
call	Delay10us		;interframe delay (required between ethernet packets)

.ENDMACRO

;---------------------------------------------------------------------------------

